#-------------------------------------------------------------------------------
# Subdirectories for Hysteresis test cases.
#-------------------------------------------------------------------------------

#-------------------------------------------------------------------------------
# Subdirectories for solver test cases
#-------------------------------------------------------------------------------

if(USE_LIS)
  add_subdirectory(Solver/lis)
endif()


if(USE_PHIST)
  add_subdirectory(Solver/phist/mech)
endif()
if(USE_FEAST)
  if(TESTSUITE_INFO_XML)
    ADD_SUBDIRECTORY(Solver/feast/stochasticEstimate)
  endif()
  ADD_SUBDIRECTORY(Solver/feast/generalisedEVP-real-symmetric)
  ADD_SUBDIRECTORY(Solver/feast/generalisedEVP-complex-symmetric)
  # tests with complex modes require appropriate mode shape comparison -> activate only when using *L2diff mdoes
  if( (TESTSUITE_CFSTOOL_MODE STREQUAL "relL2diff") OR (TESTSUITE_CFSTOOL_MODE STREQUAL "L2diff") )
    ADD_SUBDIRECTORY(Solver/feast/customSearchContour)
    ADD_SUBDIRECTORY(Solver/feast/generalisedEVP-complex-hermitian)
    ADD_SUBDIRECTORY(Solver/feast/generalisedEVP-complex-general)
    ADD_SUBDIRECTORY(Solver/feast/generalisedEVP-real-general)
    ADD_SUBDIRECTORY(Solver/feast/quadraticEVP-complex-general)
    ADD_SUBDIRECTORY(Solver/feast/quadraticEVP-complex-symmetric)
    ADD_SUBDIRECTORY(Solver/feast/quadraticEVP-real-general)
    ADD_SUBDIRECTORY(Solver/feast/quadraticEVP-real-symmetric)
    ADD_SUBDIRECTORY(Solver/feast/left-eigenvectors-to-hdf5)
    if(TESTSUITE_INFO_XML)
      ADD_SUBDIRECTORY(Solver/feast/eigenvalues-to-info-xml)
      ADD_SUBDIRECTORY(Solver/feast/nodes-and-weights-to-info-xml)
    endif()
  endif()
endif()
if(USE_FEAST)
  add_subdirectory(Solver/quadraticEigenSolver/1dOscillator_eigenValue_firstCompanion)
  add_subdirectory(Solver/quadraticEigenSolver/1dOscillator_eigenValue_secondCompanion)
  add_subdirectory(Solver/quadraticEigenSolver/1dOscillator_eigenFrequency_firstCompanion)
endif()
IF(USE_PETSC)
  ADD_SUBDIRECTORY(Solver/petsc/AlgebraicMultigrid)
  ADD_SUBDIRECTORY(Solver/petsc/GeometricMultigrid)
  ADD_SUBDIRECTORY(Solver/petsc/Iterative)
  ADD_SUBDIRECTORY(Solver/petsc/Unstructured)
ENDIF(USE_PETSC)
if(USE_ARPACK)
  ADD_SUBDIRECTORY(Solver/Arpack/EigenValueDriver_Generalized)
  ADD_SUBDIRECTORY(Solver/Arpack/EigenValueDriver_Standard)
  ADD_SUBDIRECTORY(Solver/Arpack/EigenValueDriver_Quadratic)
endif()
if(TESTSUITE_PYTHON)
  # these external solver test cases rely on python
  ADD_SUBDIRECTORY(Solver/externalSolver/staticRealCoord)
  ADD_SUBDIRECTORY(Solver/externalSolver/harmonicComplexCoord)
  ADD_SUBDIRECTORY(Solver/externalSolver/harmonicComplexArray)
  ADD_SUBDIRECTORY(Solver/externalSolver/transientRealArray)
  ADD_SUBDIRECTORY(Solver/externalEigenSolver/EigenFrequencyComplexInput)
  ADD_SUBDIRECTORY(Solver/externalEigenSolver/EigenFrequencyRealInput)
  ADD_SUBDIRECTORY(Solver/externalEigenSolver/EigenValueGeneralizedComplexResult)
  ADD_SUBDIRECTORY(Solver/externalEigenSolver/EigenValueStandardArray)
endif()

#-------------------------------------------------------------------------------
# Subdirectories for Acoustics test cases.
#-------------------------------------------------------------------------------
if(USE_FLANN AND USE_LIS)
  ADD_SUBDIRECTORY(Singlefield/Acoustics/Abc2dcsvt)
endif()
ADD_SUBDIRECTORY(Singlefield/Acoustics/Abc3d)
if(USE_LIS)
  ADD_SUBDIRECTORY(Singlefield/Acoustics/Abc2d)
  ADD_SUBDIRECTORY(Singlefield/Acoustics/Pml2d)
endif(USE_LIS)
ADD_SUBDIRECTORY(Singlefield/Acoustics/ConsInterp3d)
ADD_SUBDIRECTORY(Singlefield/Acoustics/ImpedanceBC_axi)
ADD_SUBDIRECTORY(Singlefield/Acoustics/PmlVarDensity2d)
ADD_SUBDIRECTORY(Singlefield/Acoustics/Pml2dInfCylSquareRotatePotential)
ADD_SUBDIRECTORY(Singlefield/Acoustics/Pml2dInfCylSquareRotatePressure)
if(USE_SUITESPARSE)
  ADD_SUBDIRECTORY(Singlefield/Acoustics/Mortar3d)
endif()
ADD_SUBDIRECTORY(Singlefield/Acoustics/Nitsche2d)
ADD_SUBDIRECTORY(Singlefield/Acoustics/PlaneWavePML3d)
ADD_SUBDIRECTORY(Singlefield/Acoustics/Periodic2d)
ADD_SUBDIRECTORY(Singlefield/Acoustics/Periodic3d)
ADD_SUBDIRECTORY(Singlefield/Acoustics/DipolSrcLocation)
#ADD_SUBDIRECTORY(Singlefield/Acoustics/WaveFlowTempPml)
IF(USE_PARDISO)
  ADD_SUBDIRECTORY(Singlefield/Acoustics/AcousticChannelHarmonicTreeSampling)
  ADD_SUBDIRECTORY(Singlefield/Acoustics/AcousticChannelHarmonicTreeSamplingRestart)
  ADD_SUBDIRECTORY(Singlefield/Acoustics/AcousticChannelHarmonicTreeSamplingRestartFinished)
  ADD_SUBDIRECTORY(Singlefield/Acoustics/ComplexMat)
  ADD_SUBDIRECTORY(Singlefield/Acoustics/Muffler1MPPnmg)
  ADD_SUBDIRECTORY(Singlefield/Acoustics/PCWE)
  ADD_SUBDIRECTORY(Singlefield/Acoustics/LighthillVector)
  ADD_SUBDIRECTORY(Singlefield/Acoustics/CircleAcouSlice2dABCs)
  ADD_SUBDIRECTORY(Singlefield/Acoustics/AcousticChannelTETpFEM)
  ADD_SUBDIRECTORY(Singlefield/Acoustics/Mortar2d)
  ADD_SUBDIRECTORY(Singlefield/Magnetics/VelocityTerm2D)
  ADD_SUBDIRECTORY(Singlefield/Magnetics/VelocityTerm3D)
  ADD_SUBDIRECTORY(Singlefield/Acoustics/Pml3dTrans)
  ADD_SUBDIRECTORY(Singlefield/Acoustics/Pml2dTrans)
  ADD_SUBDIRECTORY(Singlefield/Acoustics/Mortar2dCurved)
  ADD_SUBDIRECTORY(Singlefield/Acoustics/RotationNCAcouPotential)
  ADD_SUBDIRECTORY(Singlefield/Acoustics/RotationNCAcouPressure)
  ADD_SUBDIRECTORY(Singlefield/Acoustics/RotationNCMultiRegion)
ENDIF(USE_PARDISO)
add_subdirectory(Singlefield/Acoustics/QuaterPipeBoundaryLayer3d)
if(TESTSUITE_PYTHON)
  add_subdirectory(Singlefield/Acoustics/PmlCurvilinear3dReadWriteGeometryFiles)
endif()
add_subdirectory(Singlefield/Acoustics/PmlCurvilinear3dSimpleGeomPlaneXYZ)
add_subdirectory(Singlefield/Acoustics/PmlClassic3dWithGeneratedLayer)
add_subdirectory(Singlefield/Acoustics/PmlCurvilinear3dSimpleGeomQuarterCylinderX)
add_subdirectory(Singlefield/Acoustics/PmlCurvilinear3dSimpleGeomQuarterCylinderY)
add_subdirectory(Singlefield/Acoustics/PmlCurvilinear3dSimpleGeomQuarterCylinderZ)
add_subdirectory(Singlefield/Acoustics/PmlCurvilinear3dSimpleGeomQuarterSphereAcouPotential)
if(USE_CGAL AND USE_EIGEN)
  add_subdirectory(Singlefield/Acoustics/PmlCurvilinear3dCgalEllipsoid)
endif(USE_CGAL AND USE_EIGEN)

#-------------------------------------------------------------------------------
# Subdirectories for water waves test cases.
#-------------------------------------------------------------------------------
add_subdirectory(Singlefield/WaterWaves/Container2Dacceleration)
add_subdirectory(Singlefield/WaterWaves/Container2DforceTorque)
add_subdirectory(Singlefield/WaterWaves/Container3DforceTorque)
if(USE_PARDISO)
  add_subdirectory(Singlefield/WaterWaves/PML2d)
  if(USE_ARPACK)
    add_subdirectory(Singlefield/WaterWaves/SloshingEV2D_FiniteDepth)
    add_subdirectory(Singlefield/WaterWaves/SloshingEV2D_InfiniteDepthMapping_exponential)
    add_subdirectory(Singlefield/WaterWaves/SloshingEV2D_InfiniteDepthMapping_tangens)
    add_subdirectory(Singlefield/WaterWaves/SloshingEV2D_InfiniteDepthMapping_rational)
  endif()
endif()

#-------------------------------------------------------------------------------
# Subdirectories for AcousticMixed and APE test cases.
#-------------------------------------------------------------------------------
ADD_SUBDIRECTORY(Singlefield/AcousticMixed/channel3d_sfem_abc)

#-------------------------------------------------------------------------------
# Subdirectories for smoothPDE test cases.
#-------------------------------------------------------------------------------
ADD_SUBDIRECTORY(Singlefield/Smooth/plungertrans2d)
ADD_SUBDIRECTORY(Singlefield/Smooth/RotatedChamberL2Norm2D)
ADD_SUBDIRECTORY(Singlefield/Smooth/ChamberL2Norm2DHarmonic)

#-------------------------------------------------------------------------------
# Subdirectories for Split PDE test cases.
#-------------------------------------------------------------------------------
ADD_SUBDIRECTORY(Singlefield/Split/Dipol2dMapping)
ADD_SUBDIRECTORY(Singlefield/Split/AnalyticField2dScalar)
ADD_SUBDIRECTORY(Singlefield/Split/Cylinder2dScalar)
ADD_SUBDIRECTORY(Singlefield/Split/AnalyticField2dVector)
ADD_SUBDIRECTORY(Singlefield/Split/Cylinder2dVector)
IF(USE_PARDISO)
  ADD_SUBDIRECTORY(Singlefield/Split/curlcurlA3d)
ENDIF(USE_PARDISO)
#-------------------------------------------------------------------------------
# Subdirectories for Electrostatics test cases.
#-------------------------------------------------------------------------------
ADD_SUBDIRECTORY(Singlefield/Electrostatics/Cube3d)
ADD_SUBDIRECTORY(Singlefield/Electrostatics/ConstPolarizedSphere)
ADD_SUBDIRECTORY(Singlefield/Electrostatics/ConstPolarizedHalfSphere)
ADD_SUBDIRECTORY(Singlefield/Electrostatics/ConstPolarizedQuarterSphere)
ADD_SUBDIRECTORY(Singlefield/Electrostatics/ConstPolarizedAxiSphere)
ADD_SUBDIRECTORY(Singlefield/Electrostatics/ConstPolarizedElectret2D)
ADD_SUBDIRECTORY(Singlefield/Electrostatics/ConstPolarizedElectret3D)
ADD_SUBDIRECTORY(Singlefield/Electrostatics/ConstPolarizedElectrode2D)
ADD_SUBDIRECTORY(Singlefield/Electrostatics/ConstPolarizedElectrode3D)
ADD_SUBDIRECTORY(Singlefield/Electrostatics/UnitCubeNL)
IF(USE_PARDISO)
  ADD_SUBDIRECTORY(Singlefield/Electrostatics/LShapedDomain)
  ADD_SUBDIRECTORY(Singlefield/Electrostatics/CylCapAxi)
  ADD_SUBDIRECTORY(Singlefield/Electrostatics/CylCap3D)
  ADD_SUBDIRECTORY(Singlefield/Electrostatics/Capacitor2dPlane_DepthScaled)
  ADD_SUBDIRECTORY(Singlefield/Electrostatics/Cube2dMortar)
  ADD_SUBDIRECTORY(Singlefield/Electrostatics/Cube3dMortar)
  ADD_SUBDIRECTORY(Singlefield/Electrostatics/MovingMortar)
  ADD_SUBDIRECTORY(Singlefield/Electrostatics/ChargeExcitation_ScalarPreisach_FDJacobian_ArmijoLS)
  ADD_SUBDIRECTORY(Singlefield/Electrostatics/VoltageExcitation_VectorPreisachSutor_InitialState_FieldParallelBoundary)
  ADD_SUBDIRECTORY(Singlefield/Electrostatics/ChargeExcitationCorner_VectorPreisach)
  ADD_SUBDIRECTORY(Singlefield/Electrostatics/UnitCubeMH_linear)
  ADD_SUBDIRECTORY(Singlefield/Electrostatics/UnitCubeMH_nonlinear)
  ADD_SUBDIRECTORY(Singlefield/Electrostatics/CylinderMH_IDBC)
  ADD_SUBDIRECTORY(Singlefield/Electrostatics/PrismaHyst_transient)
  ADD_SUBDIRECTORY(Singlefield/Electrostatics/PrismaHyst_MH)
#  ADD_SUBDIRECTORY(Singlefield/Electrostatics/ScalPreisachVoltage)
#  ADD_SUBDIRECTORY(Singlefield/Electrostatics/ScalPreisachCharge)
#  ADD_SUBDIRECTORY(Singlefield/Electrostatics/VecPreisachCharge)
#  ADD_SUBDIRECTORY(Singlefield/Electrostatics/VecPreisachCharge2)
#  ADD_SUBDIRECTORY(Singlefield/Electrostatics/VecPreisachVoltage)
#  ADD_SUBDIRECTORY(Singlefield/Electrostatics/VecPreisachMovingVoltage)
  ADD_SUBDIRECTORY(Singlefield/Electrostatics/Periodic2D)
  IF(USE_CGAL)
    ADD_SUBDIRECTORY(Singlefield/Electrostatics/Periodic3D)
  ENDIF(USE_CGAL)
ENDIF(USE_PARDISO)

#-------------------------------------------------------------------------------
# Subdirectories for Test test cases.
#-------------------------------------------------------------------------------
ADD_SUBDIRECTORY(Singlefield/Test/TwoMat)
ADD_SUBDIRECTORY(Singlefield/Test/Geometry3D)

#-------------------------------------------------------------------------------
# Subdirectories for ElecCurrent test cases.
#-------------------------------------------------------------------------------
IF(USE_PARDISO)
  ADD_SUBDIRECTORY(Singlefield/ElecConduction/OhmsLaw)
ENDIF()
ADD_SUBDIRECTORY(Singlefield/ElecConduction/NormalCurrDens)
#ADD_SUBDIRECTORY(Singlefield/ElecConduction/SparkGap)
#ADD_SUBDIRECTORY(Singlefield/ElecConduction/DiodeTempDep/)
#ADD_SUBDIRECTORY(Singlefield/ElecConduction/Transistor/)
#ADD_SUBDIRECTORY(Singlefield/ElecConduction/TransistorTempDep/)



#-------------------------------------------------------------------------------
# Subdirectories for quasistatic electric field.
#-------------------------------------------------------------------------------
ADD_SUBDIRECTORY(Singlefield/ElecQuasistatic/NormalCurrDens)
ADD_SUBDIRECTORY(Singlefield/ElecQuasistatic/Cube2NMG)
ADD_SUBDIRECTORY(Singlefield/ElecQuasistatic/ElecCondTensorFromFile)


#-------------------------------------------------------------------------------
# Subdirectories for Heat test cases.
#-------------------------------------------------------------------------------
ADD_SUBDIRECTORY(Singlefield/Heat/SlabVolSource)
add_subdirectory(Singlefield/Heat/ExpressionHeatSource)
ADD_SUBDIRECTORY(Singlefield/Heat/heat2D_thermalRadiationBC)
ADD_SUBDIRECTORY(Singlefield/Heat/heat2D_L2Norm)
IF(USE_PARDISO)
  ADD_SUBDIRECTORY(Singlefield/Heat/HeatNLcondAndCap3d)
  ADD_SUBDIRECTORY(Singlefield/Heat/HeatMortar)
  ADD_SUBDIRECTORY(Singlefield/Heat/HeatSource)
  ADD_SUBDIRECTORY(Singlefield/Heat/ConvDiff2D)
  #ADD_SUBDIRECTORY(Singlefield/Heat/ConvDiff2D_InfMapSource)
  ADD_SUBDIRECTORY(Singlefield/Heat/ConvDiff2D_Source)
  ADD_SUBDIRECTORY(Singlefield/Heat/2DPlateSpaceDependent)
  ADD_SUBDIRECTORY(Singlefield/Heat/TempDependDensity)
  ADD_SUBDIRECTORY(Singlefield/Heat/ConvDiff2D_heatTrans)
  ADD_SUBDIRECTORY(Singlefield/Heat/heat2D_Dirichlet)
  ADD_SUBDIRECTORY(Singlefield/Heat/heat2D_heatTransportBC)
  ADD_SUBDIRECTORY(Singlefield/Heat/Sphere3D)
ENDIF(USE_PARDISO)
if(USE_EMBEDDED_PYTHON)
  add_subdirectory(Singlefield/Heat/HeatNLPythonSource)
endif()


#-------------------------------------------------------------------------------
# Subdirectories for Flow test cases.
#-------------------------------------------------------------------------------
if(USE_SUITESPARSE)
  ADD_SUBDIRECTORY(Singlefield/Flow/Channel2dMeanFlowPerturbed)
  ADD_SUBDIRECTORY(Singlefield/Flow/CylinderStokes)
  ADD_SUBDIRECTORY(Singlefield/Flow/LidDrivenCavity)
  ADD_SUBDIRECTORY(Singlefield/Flow/LidDrivenCavityStab)
  ADD_SUBDIRECTORY(Singlefield/Flow/OscillatingPlateHarmPerturbed)
  ADD_SUBDIRECTORY(Singlefield/Flow/Stokes3DPerturbed)
  ADD_SUBDIRECTORY(Singlefield/Flow/Stokes3DPerturbedStabBochev)
  ADD_SUBDIRECTORY(Singlefield/Flow/StokesPerturbed)
  if(USE_FLANN)
    ADD_SUBDIRECTORY(Singlefield/Flow/Channel2dMeanFlowFromCSV)  
  endif()
endif(USE_SUITESPARSE)
IF(USE_PARDISO)
  ADD_SUBDIRECTORY(Singlefield/Flow/Channel2D)
endif()

#-------------------------------------------------------------------------------
# Subdirectories for LinFlow test cases.
#-------------------------------------------------------------------------------
ADD_SUBDIRECTORY(Singlefield/LinFlow/StokesBoundaryLayer2D)
ADD_SUBDIRECTORY(Singlefield/LinFlow/StokesBoundaryLayer2DpFEM)
ADD_SUBDIRECTORY(Singlefield/LinFlow/PlaneWave2DConvection)
ADD_SUBDIRECTORY(Singlefield/LinFlow/PlaneWave2DBulkViscosity)
ADD_SUBDIRECTORY(Singlefield/LinFlow/PlaneWave3DBulkViscosity)
ADD_SUBDIRECTORY(Singlefield/LinFlow/PlaneWave2DDynamicViscosity)
ADD_SUBDIRECTORY(Singlefield/LinFlow/CylindricalWave2D)
ADD_SUBDIRECTORY(Singlefield/LinFlow/RotatingDisk3D)
ADD_SUBDIRECTORY(Singlefield/LinFlow/PlaneWave2DBulkViscosity-rotated)
ADD_SUBDIRECTORY(Singlefield/LinFlow/ViscousChannel-normalImpedance)
ADD_SUBDIRECTORY(Singlefield/LinFlow/ViscousChannel-ABC)
ADD_SUBDIRECTORY(Singlefield/LinFlow/PlaneWave2DGridVelC1)
ADD_SUBDIRECTORY(Singlefield/LinFlow/PlaneWave2DGridVelC2)
ADD_SUBDIRECTORY(Singlefield/LinFlow/PlaneWave2DGridVelC1C2)
ADD_SUBDIRECTORY(Singlefield/LinFlow/PlaneWave2DPostProc)
ADD_SUBDIRECTORY(Singlefield/LinFlow/PlaneWaveAxi)
ADD_SUBDIRECTORY(Singlefield/LinFlow/ViscousDissipationTotalStrainPart)
ADD_SUBDIRECTORY(Singlefield/LinFlow/ViscousDissipationDivergencePart)
ADD_SUBDIRECTORY(Singlefield/LinFlow/ViscousDissipationPower)
ADD_SUBDIRECTORY(Singlefield/LinFlow/IntensityAndPowerPressureOnly)
ADD_SUBDIRECTORY(Singlefield/LinFlow/IntensityAndPower)
if(USE_ARPACK)
  ADD_SUBDIRECTORY(Singlefield/LinFlow/Slit_LinFlowEV)
ENDIF()
IF(USE_PARDISO)
  ADD_SUBDIRECTORY(Singlefield/LinFlow/PlaneWave2DNoPenetrationScalarLM)
  ADD_SUBDIRECTORY(Singlefield/LinFlow/MaxwellSlipBC2D)
  ADD_SUBDIRECTORY(Singlefield/LinFlow/PlaneWave3DGridVelC1Rotated)
  ADD_SUBDIRECTORY(Singlefield/LinFlow/PlaneWave3DGridVelC2Rotated)
  ADD_SUBDIRECTORY(Singlefield/LinFlow/PlaneWave3DGridVelC1C2Rotated)
ENDIF(USE_PARDISO)

#-------------------------------------------------------------------------------
# Subdirectories for Magnetics test cases.
#-------------------------------------------------------------------------------
ADD_SUBDIRECTORY(Singlefield/Magnetics/BarMagnet)
ADD_SUBDIRECTORY(Singlefield/Magnetics/ForceMaxwell2D)
if(USE_GIDPOST)
  ADD_SUBDIRECTORY(Singlefield/Magnetics/Anisotropic3d)
endif(USE_GIDPOST)
ADD_SUBDIRECTORY(Singlefield/Magnetics/CoaxEdgeAnisotropicConductivity)
if(TESTSUITE_INFO_XML)
  ADD_SUBDIRECTORY(Singlefield/Magnetics/DirectTestOfHystOperator)
endif()
ADD_SUBDIRECTORY(Singlefield/Magnetics/Coil2dNlTrans)
ADD_SUBDIRECTORY(Singlefield/Magnetics/Coil3DEdgeNL)
ADD_SUBDIRECTORY(Singlefield/Magnetics/CurrentSheet3D)
ADD_SUBDIRECTORY(Singlefield/Magnetics/Coil3dTransientEdgeNL)
#ADD_SUBDIRECTORY(Singlefield/Magnetics/Coil3DEdgeNLTwoLevel)
ADD_SUBDIRECTORY(Singlefield/Magnetics/CylindricCoilEdge)
ADD_SUBDIRECTORY(Singlefield/Magnetics/Coil3DVoltEdge)
ADD_SUBDIRECTORY(Singlefield/Magnetics/Coil3DExtJ)
#ADD_SUBDIRECTORY(Singlefield/Magnetics/ScalPreisachCoil)
ADD_SUBDIRECTORY(Singlefield/Magnetics/OCore2D)
ADD_SUBDIRECTORY(Singlefield/Magnetics/OCore3D)
ADD_SUBDIRECTORY(Singlefield/Magnetics/OCoreQuasi3D)
ADD_SUBDIRECTORY(Singlefield/Magnetics/OpenCircuit_Mayergoyz5_FixpointHlocalized_goldenSectionLinesearch)
ADD_SUBDIRECTORY(Singlefield/Magnetics/OpenCircuit_Scalar_IncrementalMaterial_multipleLinesearches)
ADD_SUBDIRECTORY(Singlefield/Magnetics/ClosedCircuit_Mayergoyz3_FixpointH_noLinesearch)
ADD_SUBDIRECTORY(Singlefield/Magnetics/ClosedCircuit_SutorRevised_QuasiNewtonFD_nonMonotoneArmijoLinesearch)
ADD_SUBDIRECTORY(Singlefield/Magnetics/Coil3D_Mayergoyz9_FixpointH_noLinesearch)
ADD_SUBDIRECTORY(Singlefield/Magnetics/Coil3D_Scalar_FixpointB_bestResidualLinesearch)
ADD_SUBDIRECTORY(Singlefield/Magnetics/Coil3D_SutorRevised_QuasiNewtonChord_noLinesearch)
ADD_SUBDIRECTORY(Singlefield/Magnetics/EBVecHyst_3dsphere_noLineSearch)
ADD_SUBDIRECTORY(Singlefield/Magnetics/EBVecHyst_3dsphere_heavy)
ADD_SUBDIRECTORY(Singlefield/Magnetics/EBVecHyst_3dsphere_Armijo)
ADD_SUBDIRECTORY(Singlefield/Magnetics/EBVecHyst_3dsphere_ArmijoRegularized)
ADD_SUBDIRECTORY(Singlefield/Magnetics/EBVecHyst_3dtoruscoil)
ADD_SUBDIRECTORY(Singlefield/Magnetics/EBVecHyst_2dfingerElectrode)
#ADD_SUBDIRECTORY(Singlefield/Magnetics/EBVecHyst_2dmixedRegions)
IF(USE_PARDISO)
  ADD_SUBDIRECTORY(Singlefield/Magnetics/ForceVWP2D)
  ADD_SUBDIRECTORY(Singlefield/Magnetics/BlockConstFlux)
  ADD_SUBDIRECTORY(Singlefield/Magnetics/Coil2dMortar)
  ADD_SUBDIRECTORY(Singlefield/Darwin/ParallelPlateCapacitor)
  ADD_SUBDIRECTORY(Singlefield/Darwin/ParallelPlateCapacitor_doubleL)
  ADD_SUBDIRECTORY(Singlefield/Magnetics/CurrentSheet3DMH)
  ADD_SUBDIRECTORY(Singlefield/Magnetics/FlatPlateHarmonicLin)
  ADD_SUBDIRECTORY(Singlefield/Magnetics/TrafoNetwork)
  if(USE_METIS)
    ADD_SUBDIRECTORY(Singlefield/Magnetics/CylindricCoilEdgeTwoLevel)
    ADD_SUBDIRECTORY(Singlefield/Magnetics/ThinYoke)
    ADD_SUBDIRECTORY(Singlefield/Magnetics/BoundaryAVExcitation)
  endif()
  ADD_SUBDIRECTORY(Singlefield/Magnetics/GlobalCurrentExcitation)
  ADD_SUBDIRECTORY(Singlefield/Magnetics/GlobalVoltageExcitation)
  ADD_SUBDIRECTORY(Singlefield/Magnetics/Nitsche3DLinTrans)
  ADD_SUBDIRECTORY(Singlefield/Magnetics/Nitsche3DLinHarm)
  ADD_SUBDIRECTORY(Singlefield/Magnetics/NCEdgeHEXTET)
  ADD_SUBDIRECTORY(Singlefield/Magnetics/NCEdgeHEXTETGrad)
  ADD_SUBDIRECTORY(Singlefield/Magnetics/NCEdgeHEXTETGradHiOrder)
  ADD_SUBDIRECTORY(Singlefield/Magnetics/NCEdgeHEXHEX)
  ADD_SUBDIRECTORY(Singlefield/Magnetics/NCEdgeHEXHEXGrad)
  ADD_SUBDIRECTORY(Singlefield/Magnetics/NCEdgeHEXHEXGradHiOrder)
  ADD_SUBDIRECTORY(Singlefield/Magnetics/specialCurrentNitscheHEX)
  ADD_SUBDIRECTORY(Singlefield/Magnetics/specialCurrentNitscheHEXTET)
  ADD_SUBDIRECTORY(Singlefield/Magnetics/specialCurrentNitscheTET)
  ADD_SUBDIRECTORY(Singlefield/Magnetics/Induc3DNitscheExc)
  ADD_SUBDIRECTORY(Singlefield/Magnetics/MagScalarPot_Sandwich)
  ADD_SUBDIRECTORY(Singlefield/Magnetics/MagScalarPot_TorusCoil)
  ADD_SUBDIRECTORY(Singlefield/Magnetics/MultiInduc3DNitscheExc)
  ADD_SUBDIRECTORY(Singlefield/Magnetics/MultiInduc3DNitscheExcNL)
  ADD_SUBDIRECTORY(Singlefield/Magnetics/OpenCircuit_Sutor_FixpointBlocalized_noLinesearch)
ENDIF(USE_PARDISO)

#-------------------------------------------------------------------------------
# Subdirectories for Mechanics test cases.
#-------------------------------------------------------------------------------
if(USE_FEAST)
  ADD_SUBDIRECTORY(Singlefield/Mechanics/RayleighDampledCantilever2D_quadraticEigenSolver)
endif()
ADD_SUBDIRECTORY(Singlefield/Mechanics/cantilevertrans2d)
ADD_SUBDIRECTORY(Singlefield/Mechanics/cantileverTrans2dNL)
ADD_SUBDIRECTORY(Singlefield/Mechanics/cube3dNL)
add_subdirectory(Singlefield/Mechanics/NodalForceExpression)
if(USE_ARPACK)
  if(USE_SUPERLU)
    ADD_SUBDIRECTORY(Singlefield/Mechanics/1dOscillatorQEVP)
    ADD_SUBDIRECTORY(Singlefield/Mechanics/DampedBeam2D)
  endif() # USE_SUPERLU
  ADD_SUBDIRECTORY(Singlefield/Mechanics/PreStress2dMS_EV)
  ADD_SUBDIRECTORY(Singlefield/Mechanics/PreStress2dMS_Harm)
  ADD_SUBDIRECTORY(Singlefield/Mechanics/PreStress3dEV)
  ADD_SUBDIRECTORY(Singlefield/Mechanics/nitscheMixedOrder)
  ADD_SUBDIRECTORY(Singlefield/Mechanics/Plate3D_MultiSequenceStep)
  ADD_SUBDIRECTORY(Singlefield/Mechanics/NormalSurfaceOscillatingSphere)
endif() # USE_ARPACK
ADD_SUBDIRECTORY(Singlefield/Mechanics/MassCMEHarm)
ADD_SUBDIRECTORY(Singlefield/Mechanics/StiffCMEHarm)
ADD_SUBDIRECTORY(Singlefield/Mechanics/ICModes2DBar)
ADD_SUBDIRECTORY(Singlefield/Mechanics/RhombicPlate)
ADD_SUBDIRECTORY(Singlefield/Mechanics/TwoMatUnitCell3D)
ADD_SUBDIRECTORY(Singlefield/Mechanics/ThermalExpansionIsotropic3D)
IF(USE_PARDISO)
  ADD_SUBDIRECTORY(Singlefield/Mechanics/bathe2dNL)
  ADD_SUBDIRECTORY(Singlefield/Mechanics/Plate3D)
  ADD_SUBDIRECTORY(Singlefield/Mechanics/MechThermNMGtransient)
  ADD_SUBDIRECTORY(Singlefield/Mechanics/Torque3dMortar)
  ADD_SUBDIRECTORY(Singlefield/Mechanics/Torque3dNitsche)
  ADD_SUBDIRECTORY(Singlefield/Mechanics/MechThermStatic)
  ADD_SUBDIRECTORY(Singlefield/Mechanics/PeriodicMech2p5D)
  ADD_SUBDIRECTORY(Singlefield/Mechanics/PwavePML2d)
  ADD_SUBDIRECTORY(Singlefield/Mechanics/SwavePML2d)
  ADD_SUBDIRECTORY(Singlefield/Mechanics/uniaxStrainPwavePML3d)
  ADD_SUBDIRECTORY(Singlefield/Mechanics/uniaxStrainSwavePML3d)
ENDIF(USE_PARDISO)
ADD_SUBDIRECTORY(Singlefield/Mechanics/Principal_stress)
if(USE_ARPACK)
  ADD_SUBDIRECTORY(Singlefield/Mechanics/BucklingPlate3D)
endif(USE_ARPACK)
if(USE_FEAST)
  ADD_SUBDIRECTORY(Singlefield/Mechanics/NormalStiffness3D)
  ADD_SUBDIRECTORY(Singlefield/Mechanics/BucklingBeam3D)
  ADD_SUBDIRECTORY(Singlefield/Mechanics/BucklingBeam2D)
endif(USE_FEAST)

#-------------------------------------------------------------------------------
# Subdirectories for complex mechanic EV test cases
#-------------------------------------------------------------------------------
if(USE_ARPACK AND TESTSUITE_INFO_XML)
  ADD_SUBDIRECTORY(Singlefield/Mechanics/dampedEV2D)  
  ADD_SUBDIRECTORY(Singlefield/Mechanics/BlochMode2D)
  ADD_SUBDIRECTORY(Singlefield/Mechanics/BlochMode3D)
endif()

#-------------------------------------------------------------------------------
# Subdirectories for optimization test cases.
#-------------------------------------------------------------------------------

#-------------------------------------------------------------------------------
# Subdirectories for Piezoelectric test cases.
#-------------------------------------------------------------------------------
ADD_SUBDIRECTORY(Coupledfield/Piezo/ShearActuatorStatic2D)
if(USE_ARPACK)
  ADD_SUBDIRECTORY(Coupledfield/Piezo/ExtensionActuatorEV2D)
endif(USE_ARPACK)
ADD_SUBDIRECTORY(Coupledfield/Piezo/HarmAxiQ)
ADD_SUBDIRECTORY(Coupledfield/Piezo/PiezoTrans2D)
ADD_SUBDIRECTORY(Coupledfield/Piezo/PiezoUnitCube)
IF(USE_PARDISO)
# not solvable by LDL; requires solver for non-symmetric systems; pardiso works
  ADD_SUBDIRECTORY(Coupledfield/Piezo/VoltageExcitation_Scalar_IncrementalMaterial_MinResidualLS)
ENDIF(USE_PARDISO)
#-------------------------------------------------------------------------------
# Subdirectories for Mechanical-Acoustic test cases.
#-------------------------------------------------------------------------------
ADD_SUBDIRECTORY(Coupledfield/MechAcou/Piston2d)
ADD_SUBDIRECTORY(Coupledfield/MechAcou/RingHarm2d)
ADD_SUBDIRECTORY(Coupledfield/MechAcou/RingHarm2dRestart)
ADD_SUBDIRECTORY(Coupledfield/MechAcou/NMGpiston)
ADD_SUBDIRECTORY(Coupledfield/MechAcou/ForwardCouplingMechAcouPressure)
IF(USE_PARDISO)
  ADD_SUBDIRECTORY(Coupledfield/MechAcou/PistonComplex1D)
ENDIF(USE_PARDISO)
if(USE_ARPACK)
  ADD_SUBDIRECTORY(Coupledfield/MechAcou/CoupledEV2D)
endif()
if(USE_FEAST AND ( (TESTSUITE_CFSTOOL_MODE STREQUAL "relL2diff") OR (TESTSUITE_CFSTOOL_MODE STREQUAL "L2diff") ) )
  ADD_SUBDIRECTORY(Coupledfield/MechAcou/CoupledEV2Dpressure)
  ADD_SUBDIRECTORY(Coupledfield/MechAcou/CoupledEV2DpressureNMG)
  ADD_SUBDIRECTORY(Coupledfield/MechAcou/ComplexSpringOscillator_EV2Dpressure)
endif()

#-------------------------------------------------------------------------------
# Subdirectories for FSI test cases.
#-------------------------------------------------------------------------------
if(USE_SUITESPARSE)
  ADD_SUBDIRECTORY(Coupledfield/FlowMech/Cantilever2d) # without umpfack wrong result
  ADD_SUBDIRECTORY(Coupledfield/FlowMech/OsciPipe2d)
  if(USE_GIDPOST)
    ADD_SUBDIRECTORY(Coupledfield/FlowMech/Channel2dFlowStab)
  endif(USE_GIDPOST)
endif(USE_SUITESPARSE)

#-------------------------------------------------------------------------------
# Subdirectories for Magneto-Mechanical test cases.
#-------------------------------------------------------------------------------
ADD_SUBDIRECTORY(Coupledfield/MagMech/SolenoidAxi)
IF(USE_PARDISO)
  ADD_SUBDIRECTORY(Coupledfield/MagMech/Plate2D)
  ADD_SUBDIRECTORY(Coupledfield/MagMech/PermaMS)
ENDIF(USE_PARDISO)
ADD_SUBDIRECTORY(Coupledfield/MagMech/Plate3DEdge)
ADD_SUBDIRECTORY(Coupledfield/MagMech/Plate3DEdgeTwoStep)
ADD_SUBDIRECTORY(Coupledfield/MagMech/PermaMSRestart)

#-------------------------------------------------------------------------------
# Subdirectories for Magneto-Strictive test cases.
#-------------------------------------------------------------------------------
ADD_SUBDIRECTORY(Coupledfield/MagStrict/MagStrictDirect)
ADD_SUBDIRECTORY(Coupledfield/MagStrict/MagStrictIter)
ADD_SUBDIRECTORY(Coupledfield/MagStrict/MagStrictMovingMag)

#-------------------------------------------------------------------------------
# Subdirectories for Magneto-Mechanical-Acoustic test cases.
#-------------------------------------------------------------------------------
IF(USE_PARDISO)
  ADD_SUBDIRECTORY(Coupledfield/MagMechAcou/PlateAboveCoilFluid2D)
  ADD_SUBDIRECTORY(Coupledfield/MagStrict/MagStrictMovingMortarMeshUpdate)
ENDIF(USE_PARDISO)

#-------------------------------------------------------------------------------
# Subdirectories for Elec-Therm test cases.
#-------------------------------------------------------------------------------
IF(USE_PARDISO)
  ADD_SUBDIRECTORY(Coupledfield/ElecTherm/ElTh_Static)
  ADD_SUBDIRECTORY(Coupledfield/ElecTherm/ElTh_NMGtransient)
ENDIF(USE_PARDISO)

#-------------------------------------------------------------------------------
# Subdirectories for Electrostatic-Mechanic test cases.
#-------------------------------------------------------------------------------
add_subdirectory(Coupledfield/ElecMech/ElecForcesCapacitorHarmonic3D)
add_subdirectory(Coupledfield/ElecMech/ElecForcesCapacitorStatic2D)
add_subdirectory(Coupledfield/ElecMech/ElecForcesCapacitorStatic3D)
add_subdirectory(Coupledfield/ElecMech/ElecForcesConductingSpheres)
add_subdirectory(Coupledfield/ElecMech/ElectricStrainUnitCubeStatic)
add_subdirectory(Coupledfield/ElecMech/ElectricStrainUnitCubeHarmonic)
add_subdirectory(Coupledfield/ElecMech/ElectricStrainUnitCubeTransient)
#-------------------------------------------------------------------------------
# Subdirectories for Magnetic-Thermal test cases.
#-------------------------------------------------------------------------------
IF(USE_PARDISO)
  ADD_SUBDIRECTORY(Coupledfield/MagTherm/magTherm_Plate)
  ADD_SUBDIRECTORY(Coupledfield/MagTherm/magTherm_Plate_HarmStat)
  ADD_SUBDIRECTORY(Coupledfield/MagTherm/magTherm_Plate_HarmStat_HiOrder)
  ADD_SUBDIRECTORY(Coupledfield/MagTherm/magTherm_Plate_tempDepend)
ENDIF()
IF(USE_PARDISO)
  ADD_SUBDIRECTORY(Coupledfield/MagTherm/SimplePlate_tempdepend_BH_analytic)
  ADD_SUBDIRECTORY(Coupledfield/MagTherm/SimplePlate_tempdepend_BH_smoothspline)
ENDIF()
ADD_SUBDIRECTORY(Coupledfield/MagTherm/NetworkHeat_HarmonicIterative)


#-------------------------------------------------------------------------------
# Subdirectories for linearized flow coupled to acoustics cases.
#-------------------------------------------------------------------------------
IF(USE_PARDISO)
  # ADD_SUBDIRECTORY(Coupledfield/LinFlowAcou/Viscous2D)
  ADD_SUBDIRECTORY(Coupledfield/LinFlowAcou/PlaneWave2D)
  ADD_SUBDIRECTORY(Coupledfield/LinFlowAcou/PlaneWave2DacouPot)
ENDIF(USE_PARDISO)


#-------------------------------------------------------------------------------
# Subdirectories for linearized flow coupled to mechanics cases.
#-------------------------------------------------------------------------------
IF(USE_PARDISO)
  # ADD_SUBDIRECTORY(Coupledfield/LinFlowMech/Cantilever2dCompressible)
  ADD_SUBDIRECTORY(Coupledfield/LinFlowMech/PlaneWave2D)
  ADD_SUBDIRECTORY(Coupledfield/LinFlowMech/RotatingDisc2D)
  ADD_SUBDIRECTORY(Coupledfield/LinFlowMech/CylindricalWave2D)
  ADD_SUBDIRECTORY(Coupledfield/LinFlowMech/PlaneWave2DMortar)
  ADD_SUBDIRECTORY(Coupledfield/LinFlowMech/CylindricalWave2DMortar)
  ADD_SUBDIRECTORY(Coupledfield/LinFlowMech/PlaneWave1DMortar)
ENDIF(USE_PARDISO)

#-------------------------------------------------------------------------------
# Subdirectories for linearized flow coupled to mechanics and smooth cases.
#-------------------------------------------------------------------------------
IF(USE_PARDISO)
  ADD_SUBDIRECTORY(Coupledfield/LinFlowMechSmooth/CompressedChamber2D)
ENDIF(USE_PARDISO)

#-------------------------------------------------------------------------------
# Subdirectories for linearized flow coupled to mechanics, smooth and electrostatic cases.
#-------------------------------------------------------------------------------
ADD_SUBDIRECTORY(Coupledfield/LinFlowMechSmoothElectrostatic/ElecForceCompressedChamber2D)

#-------------------------------------------------------------------------------
# Subdirectories for linearized flow coupled to heat cases.
#-------------------------------------------------------------------------------
IF(USE_PARDISO)
  ADD_SUBDIRECTORY(Coupledfield/LinFlowHeat/CavityThermoviscous)
ENDIF(USE_PARDISO)
ADD_SUBDIRECTORY(Coupledfield/LinFlowHeat/symmetricCavityThermoviscous)
ADD_SUBDIRECTORY(Coupledfield/LinFlowHeat/symmetricThermoviscousElectricPowerDensity)
ADD_SUBDIRECTORY(Coupledfield/LinFlowHeat/symmetricThermoviscousHeatFluxTransportSourceDensity)
#-------------------------------------------------------------------------------
# Subdirectories for linearized flow coupled to smooth.
#-------------------------------------------------------------------------------
IF(USE_PARDISO)
  ADD_SUBDIRECTORY(Coupledfield/LinFlowSmooth/ChannelUpdateGeom)
  ADD_SUBDIRECTORY(Coupledfield/LinFlowSmooth/RotatingDiscALE)
ENDIF(USE_PARDISO)

#-------------------------------------------------------------------------------
# Subdirectories for linearized flow coupled to smooth and acoustic.
#-------------------------------------------------------------------------------
IF(USE_PARDISO)
  ADD_SUBDIRECTORY(Coupledfield/LinFlowSmoothAcou/MovingMeshLoudspeaker2D)
  ADD_SUBDIRECTORY(Coupledfield/LinFlowSmoothAcou/MovingMeshLoudspeaker2DLagrangeDirichletBC)
  ADD_SUBDIRECTORY(Coupledfield/LinFlowSmoothAcou/MaxwellSlipMovingMesh2D)
ENDIF(USE_PARDISO)

#-------------------------------------------------------------------------------
# Subdirectories for WaterWaves to Mechanics
#-------------------------------------------------------------------------------
IF(USE_PARDISO)
  ADD_SUBDIRECTORY(Coupledfield/WaterWaveMech/SemiSphereHeave)
ENDIF(USE_PARDISO)

#-------------------------------------------------------------------------------
# Subdirectories for Mechanics to Smooth
#-------------------------------------------------------------------------------
IF(USE_PARDISO)
  ADD_SUBDIRECTORY(Coupledfield/MechSmooth/MechSmoothMWE2D)
  ADD_SUBDIRECTORY(Coupledfield/MechSmooth/SmoothMechMWE2D)
ENDIF(USE_PARDISO)
ADD_SUBDIRECTORY(Coupledfield/MechSmooth/coupledCantileverTrans2dNL)
ADD_SUBDIRECTORY(Coupledfield/MechSmooth/CompressedChamberContact2D)

#-------------------------------------------------------------------------------
# Structural Optimization
#-------------------------------------------------------------------------------
ADD_SUBDIRECTORY(Optimization/Technical/load_ersatzmaterial)
ADD_SUBDIRECTORY(Optimization/Technical/opt_results)
ADD_SUBDIRECTORY(Optimization/Technical/InitialDesign)
ADD_SUBDIRECTORY(Optimization/Technical/no_elem_cache)
ADD_SUBDIRECTORY(Optimization/Technical/enforce_unstruct)
ADD_SUBDIRECTORY(Optimization/Technical/mech_2d)
ADD_SUBDIRECTORY(Optimization/Technical/transfer_expression)
if(USE_EMBEDDED_PYTHON)
  add_subdirectory(Optimization/Technical/python_function)
  if(USE_SNOPT)
    add_subdirectory(Optimization/Technical/local_python_function)
  endif()
endif(USE_EMBEDDED_PYTHON)
ADD_SUBDIRECTORY(Optimization/Regularization/material_filter)
# ADD_SUBDIRECTORY(Optimization/TwoScale/TwoScaleVolume)
if(USE_ARPACK)
  ADD_SUBDIRECTORY(Optimization/Technical/multisequence_results)
endif(USE_ARPACK)

ADD_SUBDIRECTORY(Optimization/Technical/grad_check_unstruct)
ADD_SUBDIRECTORY(Optimization/Regularization/solid_heaviside)
ADD_SUBDIRECTORY(Optimization/Regularization/tanh)
ADD_SUBDIRECTORY(Optimization/Technical/static_bimat)
   # Test second order pfem for min compliance
ADD_SUBDIRECTORY(Optimization/Technical/mech_2d_pfem)
if(TESTSUITE_INFO_XML)
  ADD_SUBDIRECTORY(Optimization/Homogenization/homogenize_only)
  ADD_SUBDIRECTORY(Optimization/Homogenization/homogenize_only_3d)
  ADD_SUBDIRECTORY(Optimization/Homogenization/homogenize_sheared_mesh)
  ADD_SUBDIRECTORY(Optimization/Homogenization/heat_conduction/homogeneous_material_2d)
  ADD_SUBDIRECTORY(Optimization/Homogenization/heat_conduction/homogeneous_material_3d)
  ADD_SUBDIRECTORY(Optimization/Homogenization/heat_conduction/two_materials_2d)
  ADD_SUBDIRECTORY(Optimization/Homogenization/heat_conduction/two_materials_2d_diag)
  ADD_SUBDIRECTORY(Optimization/Homogenization/heat_conduction/two_materials_3d)
  ADD_SUBDIRECTORY(Optimization/Homogenization/heat_conduction/load_density_2d)
  ADD_SUBDIRECTORY(Optimization/Homogenization/heat_conduction/one_material_density_2d)
  ADD_SUBDIRECTORY(Optimization/ShapeMap/square_sym_2d)
  ADD_SUBDIRECTORY(Optimization/ShapeMap/cubic_sym_3d)
  ADD_SUBDIRECTORY(Optimization/ShapeMap/sym_mirror_3d)
  ADD_SUBDIRECTORY(Optimization/ShapeMap/sym_diag_3d)
  if(USE_ARPACK)
    ADD_SUBDIRECTORY(Optimization/Homogenization/buckling_loadfactor)
    ADD_SUBDIRECTORY(Optimization/Homogenization/buckling_loadfactor_3d)
  ENDIF()
  ADD_SUBDIRECTORY(Optimization/MultiSequence/compliance_mech_heat)
  ADD_SUBDIRECTORY(Optimization/MultiSequence/compliance_heat_mech)
endif(TESTSUITE_INFO_XML)

# Test for native MMA w/o dependencies
add_subdirectory(Optimization/Optimizer/mma/compliance_fixed_bfgs)
add_subdirectory(Optimization/Optimizer/mma/compliance_fixed_ip)
add_subdirectory(Optimization/Optimizer/mma/compliance_robust_bfgs)
add_subdirectory(Optimization/Optimizer/mma/compliance_robust_ip)
add_subdirectory(Optimization/Optimizer/mma/compliance_svanberg_bfgs)
add_subdirectory(Optimization/Optimizer/mma/compliance_svanberg_ip)
add_subdirectory(Optimization/Optimizer/mma/hessian_single)
if(TESTSUITE_INFO_XML)
  add_subdirectory(Optimization/Optimizer/mma/hessian_multiload)
endif()

# Test for multiobjective OCM
if(TESTSUITE_INFO_XML)
  add_subdirectory(Optimization/Optimizer/ocm/multiobjective)
endif()

if(USE_EMBEDDED_PYTHON)
  add_subdirectory(Optimization/Optimizer/python/ocm)
  add_subdirectory(Optimization/Optimizer/python/mma-single)
  add_subdirectory(Optimization/Optimizer/python/mma-multiload)
  # works only with valid matlab license and matlab engine installation
  #ADD_SUBDIRECTORY(Optimization/Optimizer/python/ocm-matlab)
  #ADD_SUBDIRECTORY(Optimization/Optimizer/python//sgp-matlab/sgp-matlab-simp) 
  #ADD_SUBDIRECTORY(Optimization/Optimizer/python//sgp-matlab/DensityTimesRotAngleFiltSens2d)
  #ADD_SUBDIRECTORY(Optimization/Optimizer/python//sgp-matlab/DensityTimesRotAngleFiltParam2d)
endif()


ADD_SUBDIRECTORY(Optimization/Heat/evalDensConfigHeat)

IF(USE_SGP)
  add_subdirectory(Optimization/Optimizer/SGP/GradientCheck2d)
  add_subdirectory(Optimization/Optimizer/SGP/GradientCheck3d)
  add_subdirectory(Optimization/Optimizer/SGP/Cantilever2dSimp)
  add_subdirectory(Optimization/Optimizer/SGP/Cantilever2dSimpRot)
  add_subdirectory(Optimization/Optimizer/SGP/Rot3dX)
  add_subdirectory(Optimization/Optimizer/SGP/Rot3dXZ)
  add_subdirectory(Optimization/Optimizer/SGP/Rot3dZ)
  add_subdirectory(Optimization/Optimizer/SGP/ExactVsModelRot3dX)
    #ADD_SUBDIRECTORY(Optimization/Optimizer/SGP/zero_asymptotes/Cantilever3dTransvIsoHorizLoad)
  add_subdirectory(Optimization/Optimizer/SGP/Cantilever3dTransvIso)
  add_subdirectory(Optimization/Optimizer/SGP/Cantilever3dTransvIsoReg)
  add_subdirectory(Optimization/Optimizer/SGP/HierarchicalGrid)
  add_subdirectory(Optimization/Optimizer/SGP/SinCosFilter)
ENDIF(USE_SGP)

IF(USE_SCPIP)
  ADD_SUBDIRECTORY(Optimization/Regularization/DensityFilter)
  ADD_SUBDIRECTORY(Optimization/Technical/multiload)
  ADD_SUBDIRECTORY(Optimization/Technical/multiload_slack)
  ADD_SUBDIRECTORY(Optimization/Technical/multiload_explicit)
  ADD_SUBDIRECTORY(Optimization/Technical/dynamic_bimat)
  ADD_SUBDIRECTORY(Optimization/Technical/constant_region)
  ADD_SUBDIRECTORY(Optimization/Regularization/void_heaviside)
  ADD_SUBDIRECTORY(Optimization/Static/output)
  ADD_SUBDIRECTORY(Optimization/Homogenization/max_ortho_robust)
  ADD_SUBDIRECTORY(Optimization/Homogenization/3d_ortho_max_E)
  ADD_SUBDIRECTORY(Optimization/ParamMat/TopMat/DensityTimesRotatedTransversalIsotropic3D)
  ADD_SUBDIRECTORY(Optimization/ShapeMap/vertical)
  ADD_SUBDIRECTORY(Optimization/ShapeMap/periodic)
  ADD_SUBDIRECTORY(Optimization/ShapeMap/sym_diag)
  ADD_SUBDIRECTORY(Optimization/ShapeMap/sym_map_3d)
  ADD_SUBDIRECTORY(Optimization/Technical/scale_constraint)
  ADD_SUBDIRECTORY(Optimization/Optimizer/scpip)
  ADD_SUBDIRECTORY(Optimization/Dynamic/globalCompliance)
  ADD_SUBDIRECTORY(Optimization/Homogenization/max_e11_iso_orthotropic)
  if(TESTSUITE_INFO_XML)
    ADD_SUBDIRECTORY(Optimization/Transform/rot_compl_slack)
    ADD_SUBDIRECTORY(Optimization/Transform/rot_robust_compl)
  endif()
  ADD_SUBDIRECTORY(Optimization/ParamMat/Material/TransversalIsotropic)
  ADD_SUBDIRECTORY(Optimization/ShapeMap/linear_2d)
  ADD_SUBDIRECTORY(Optimization/Heat/Regularization)
  ADD_SUBDIRECTORY(Optimization/Heat/TempTracking)
  ADD_SUBDIRECTORY(Optimization/Heat/DesignDepLoad)
ENDIF(USE_SCPIP)

IF(USE_SNOPT)
  ADD_SUBDIRECTORY(Optimization/Technical/mech_3d)
  ADD_SUBDIRECTORY(Optimization/Regularization/robust)
  ADD_SUBDIRECTORY(Optimization/Regularization/robust_penalized)
  ADD_SUBDIRECTORY(Optimization/Regularization/robust_vary_filter)
  ADD_SUBDIRECTORY(Optimization/Regularization/slope)
  ADD_SUBDIRECTORY(Optimization/Regularization/min_perimeter)
  ADD_SUBDIRECTORY(Optimization/Regularization/max_perimeter)
  ADD_SUBDIRECTORY(Optimization/Optimizer/snopt)
  if(USE_ARPACK)
    add_subdirectory(Optimization/Dynamic/eigenfrequency)
  endif()
  add_subdirectory(Optimization/FMO/mech_coef_static)
  add_subdirectory(Optimization/Technical/global_design)
  # multisequence is not compatible due as each sequence needs a own filter to handle periodicity of the sequence correctly
  # ADD_SUBDIRECTORY(Optimization/MultiSequence/eigen_stiffness)
  if(USE_ARPACK)
    add_subdirectory(Optimization/MultiSequence/stiffness_eigen)
  endif()
  add_subdirectory(Optimization/TwoScale/HomRect)
  ADD_SUBDIRECTORY(Optimization/TwoScale/HomRect_C1)
  ADD_SUBDIRECTORY(Optimization/TwoScale/HomRect_C1_3D)
  ADD_SUBDIRECTORY(Optimization/TwoScale/HomRect_C1_non_regular)
  ADD_SUBDIRECTORY(Optimization/TwoScale/Msfem_C1)
  ADD_SUBDIRECTORY(Optimization/TwoScale/localBuckling)
  ADD_SUBDIRECTORY(Optimization/TwoScale/globalBuckling)
  #IF(USE_PARDISO AND TESTSUITE_INFO_XML)
  #  ADD_SUBDIRECTORY(Optimization/TwoScale/Heat_mech_3d)
  #ENDIF()
  ADD_SUBDIRECTORY(Optimization/ParamMat/TopMat/DensityTimesRotatedTransversalIsotropic)
  ADD_SUBDIRECTORY(Optimization/ShapeMap/slope)
  ADD_SUBDIRECTORY(Optimization/ShapeMap/profile)
  ADD_SUBDIRECTORY(Optimization/ShapeMap/profile_3d)
  ADD_SUBDIRECTORY(Optimization/ShapeMap/node_3d)
  ADD_SUBDIRECTORY(Optimization/ShapeMap/pure_profile)
  ADD_SUBDIRECTORY(Optimization/ShapeMap/tanh_sum)
  ADD_SUBDIRECTORY(Optimization/ShapeMap/sym_induced)
  ADD_SUBDIRECTORY(Optimization/ShapeMap/sym_map)
  ADD_SUBDIRECTORY(Optimization/ShapeMap/overhang_hor)
  ADD_SUBDIRECTORY(Optimization/ShapeMap/overhang_vert)
  ADD_SUBDIRECTORY(Optimization/ShapeMap/two_bar_max)
  ADD_SUBDIRECTORY(Optimization/ShapeMap/two_bar_tanh_sum)
  if(USE_EMBEDDED_PYTHON)
    ADD_SUBDIRECTORY(Optimization/ShapeMap/spaghetti_single)
    ADD_SUBDIRECTORY(Optimization/ShapeMap/spaghetti_cantilever)
    ADD_SUBDIRECTORY(Optimization/ShapeMap/spaghetti_single_iso)
    ADD_SUBDIRECTORY(Optimization/ShapeMap/spaghetti_cantilever_iso)
    ADD_SUBDIRECTORY(Optimization/ShapeMap/spaghetti_bending)
    add_subdirectory(Optimization/ShapeMap/spaghetti3d_iso)
    add_subdirectory(Optimization/ShapeMap/spaghetti_rhomax)
  endif(USE_EMBEDDED_PYTHON)

  ADD_SUBDIRECTORY(Optimization/SplineBox/eval_2d_analytic)
  ADD_SUBDIRECTORY(Optimization/SplineBox/eval_2d_file)

  IF(USE_LIS)
    ADD_SUBDIRECTORY(Optimization/ShapeMap/two_bar_3d_max)
    ADD_SUBDIRECTORY(Optimization/ShapeMap/two_bar_3d_tanh_sum)
    ADD_SUBDIRECTORY(Optimization/ShapeMap/two_bar_3d_linear)
  ENDIF(USE_LIS)
  #if(USE_PARDISO)
  #  add_subdirectory(Optimization/Mag/lin_flux_dens_1_elem)
  #  add_subdirectory(Optimization/Mag/lin_flux_dens_symm_1elem)
  #  add_subdirectory(Optimization/Mag/nonlin_flux_dens_1_elem)
  #  add_subdirectory(Optimization/Mag/nonlin_flux_dens)
  #  add_subdirectory(Optimization/Mag/lin_flux_dens_3D)
  #  add_subdirectory(Optimization/Mag/nonlin_flux_dens_3D)
  #  add_subdirectory(Optimization/Mag/mult_excitations_scaled)
  # add_subdirectory(Optimization/Mag/mag_coupling)
  # endif()
  ADD_SUBDIRECTORY(Optimization/Heat/HeatEnergy)
  IF(USE_SGPP)
    ADD_SUBDIRECTORY(Optimization/TwoScale/HomRect_SGPP)
  ENDIF(USE_SGPP)
  # see BlochMode2D above
  if(USE_ARPACK)
    if(USE_SUITESPARSE)
      ADD_SUBDIRECTORY(Optimization/Dynamic/bloch2d) # without much slower and wrong results
      ADD_SUBDIRECTORY(Optimization/Dynamic/bloch2d_search)
    endif()
    ADD_SUBDIRECTORY(Optimization/FMO/mech_coef_ev)
 endif()
ENDIF(USE_SNOPT)
if(USE_ARPACK AND USE_SUITESPARSE)
  # is evaluate optimization only
  ADD_SUBDIRECTORY(Optimization/MultiSequence/bloch_stiffness)
  ADD_SUBDIRECTORY(Optimization/MultiSequence/bloch_stiffness_robust)
endif()
IF(USE_IPOPT)
  ADD_SUBDIRECTORY(Optimization/Optimizer/ipopt)
ENDIF(USE_IPOPT)

IF(USE_PARDISO)
  ADD_SUBDIRECTORY(Optimization/LBM/SRT/lbm2dSim)
  ADD_SUBDIRECTORY(Optimization/LBM/SRT/lbm3dSim)
ENDIF(USE_PARDISO)
IF(USE_SCPIP)
  IF(USE_PARDISO)
    ADD_SUBDIRECTORY(Optimization/LBM/SRT/lbm2d)
    ADD_SUBDIRECTORY(Optimization/LBM/SRT/lbm2dParabolic)
    ADD_SUBDIRECTORY(Optimization/LBM/SRT/lbm3d)
  ENDIF(USE_PARDISO)
  ADD_SUBDIRECTORY(Optimization/LBM/SRT/lbm2dAdj)
  ADD_SUBDIRECTORY(Optimization/LBM/SRT/lbm3dAdj)
ENDIF(USE_SCPIP)

if(USE_SNOPT)
  add_subdirectory(Optimization/Stress/local_vts)
  add_subdirectory(Optimization/Stress/local_penal)
  add_subdirectory(Optimization/Stress/global)
endif()


if(USE_EMBEDDED_PYTHON)
  add_subdirectory(Technical/PythonMesher)
  add_subdirectory(Technical/PythonMesherVar)
  add_subdirectory(Technical/NodalPythonCoef)
  add_subdirectory(Technical/PythonCallback)
endif()
add_subdirectory(Technical/NodalDataFile)
if(TESTSUITE_INFO_XML)
  add_subdirectory(Technical/cdb2cfs_2D)
endif()
if(USE_CGNS)
  add_subdirectory(Technical/ShellElementConversion_CGNS)
  add_subdirectory(Technical/VolumeElementConversion_CGNS)
endif()
#-------------------------------------------------------------------------------
# CFSdat
#-------------------------------------------------------------------------------
if(BUILD_CFSDAT)
  #add_subdirectory(CFSdat/TestCategory/test1)
  IF(USE_CGAL)
    add_subdirectory(CFSdat/NearestNeighbour_hdf5)
  ENDIF(USE_CGAL)
  add_subdirectory(CFSdat/node2Cell_3D_hdf5)
  add_subdirectory(CFSdat/timeDerivative_analytical)
  add_subdirectory(CFSdat/FIR_Upsampling)
  add_subdirectory(CFSdat/FIR_Downsampling)
  add_subdirectory(CFSdat/BinaryOperations)
  add_subdirectory(CFSdat/volumeMultiplication)
  add_subdirectory(CFSdat/tensorFilter)
  IF(USE_ENSIGHT)
    add_subdirectory(CFSdat/consCellCentroid)
    add_subdirectory(CFSdat/cell2Node)
    add_subdirectory(CFSdat/cell2Node_3D_Ensight)
    IF(USE_CGAL)
      add_subdirectory(CFSdat/NearestNeighbour_2D_Ensight_scalar)
      add_subdirectory(CFSdat/conservCellCentroid_3D_Ensight)
      add_subdirectory(CFSdat/conservCutCell_3D_Ensight)
    ENDIF(USE_CGAL)
    add_subdirectory(CFSdat/timeDerivative_2D_EnSight)
    add_subdirectory(CFSdat/timeDerivative_3D_EnSight)
    IF(USE_CGAL)
      add_subdirectory(CFSdat/conservCutCell_binary_2D_Ensight)
      add_subdirectory(CFSdat/conservCutCell_2D_Ensight)
    ENDIF(USE_CGAL)
    add_subdirectory(CFSdat/staticInput)
    add_subdirectory(CFSdat/GaussDerivative)
    add_subdirectory(CFSdat/FEBasedInterpolation)
  ENDIF(USE_ENSIGHT)
  #add_subdirectory(CFSdat/SpatialDerivative_3D_Divergence) # fix the error-criterium, and re-enable afterwards!
  #add_subdirectory(CFSdat/SpatialDerivative_3D_Gradient) # fix the error-criterium, and re-enable afterwards!
  add_subdirectory(CFSdat/SpatialDerivative_3D_Curl)
  add_subdirectory(CFSdat/SpatialDerivative_2D_Divergence)
  add_subdirectory(CFSdat/SpatialDerivative_2D_Gradient)
  #add_subdirectory(CFSdat/SpatialDerivative_2D_Curl) # fix the error-criterium, and re-enable afterwards!
  IF(USE_CGAL)
    add_subdirectory(CFSdat/LambVector_3D)
    #add_subdirectory(CFSdat/LighthillSourceVector_3D) # fix the error-criterium, and re-enable afterwards!
    #add_subdirectory(CFSdat/LighthillSourceTerm_3D) # fix the error-criterium, and re-enable afterwards!
    #add_subdirectory(CFSdat/LambVector_2D) # fix the error-criterium, and re-enable afterwards!
    add_subdirectory(CFSdat/LighthillSourceVector_2D)
    add_subdirectory(CFSdat/LighthillSourceTerm_2D)
  ENDIF(USE_CGAL)  
  add_subdirectory(CFSdat/timeMean_2D_h5)
  add_subdirectory(CFSdat/TemporalBlending)
  add_subdirectory(CFSdat/MultiOutput_NN)
  IF(USE_CGAL)
    add_subdirectory(CFSdat/RBF_hdf5)
    add_subdirectory(CFSdat/RBF_2D_Ensight_scalar)
  ENDIF(USE_CGAL)
  if(USE_BLAS_LAPACK STREQUAL "MKL")
    #add_subdirectory(CFSdat/FFT_2D)
  endif(USE_BLAS_LAPACK STREQUAL "MKL")
endif() # BUILD_CFSDAT
